/* cmd_global_unbind.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_global.h"

/*
* argv[0]   command name
*/

CMD_BIND(global_cmd_unbind) {
    MYSQL_RES *res;
    MYSQL_ROW row;
    struct cmd_binding *cbind = find_botwise_cmd_binding(client->botid, client->clientid, argv[0]);
    if(client->botid == 0)
        printf_mysql_query("SELECT `id`, `function` FROM `bot_binds` WHERE `botclass` = '0' AND `botid` = '%d' AND `command` = '%s'", client->clientid, escape_string(argv[0]));
    else
        printf_mysql_query("SELECT `id`, `function` FROM `bot_binds` WHERE `botclass` = '%d' AND `command` = '%s'", client->botid, escape_string(argv[0]));
    res = mysql_use();
    if ((row = mysql_fetch_row(res)) == NULL && (!cbind || !(cbind->flags & CMDFLAG_TEMPONARY_BIND))) {
        reply(textclient, user, "NS_UNBIND_NOT_FOUND", argv[0]);
        return;
    }
    struct cmd_function *function = find_cmd_function(client->botid, cbind->func->name);
    if(function && (function->flags & CMDFLAG_REQUIRED)) {
        if(client->botid == 0)
            printf_mysql_query("SELECT `id` FROM `bot_binds` WHERE `botclass` = '0' AND `botid` = '%d' AND `function` = '%s'", client->clientid, escape_string(function->name));
        else
            printf_mysql_query("SELECT `id` FROM `bot_binds` WHERE `botclass` = '%d' AND `function` = '%s'", client->botid, escape_string(function->name));
        res = mysql_use();
        if (mysql_num_rows(res) <= 1) {
            reply(textclient, user, "NS_UNBIND_REQUIRED", function->name);
            return;
        }
    }
    unbind_botwise_cmd(client->botid, client->clientid, argv[0]);
    if(!cbind || !(cbind->flags & CMDFLAG_TEMPONARY_BIND))
        printf_mysql_query("DELETE FROM `bot_binds` WHERE `id` = '%s'", row[0]);
    reply(textclient, user, "NS_UNBIND_DONE", argv[0]);
    logEvent(event);
}
